Index: liveMedia/include/RTSPServerSupportingHTTPStreaming.hh
===================================================================
--- liveMedia/include/RTSPServerSupportingHTTPStreaming.hh	(revision 14473)
+++ liveMedia/include/RTSPServerSupportingHTTPStreaming.hh	(revision 14474)
@@ -57,7 +57,8 @@
     virtual ~RTSPClientConnectionSupportingHTTPStreaming();
 
   protected: // redefined virtual functions
-    virtual void handleHTTPCmd_StreamingGET(char const* urlSuffix, char const* fullRequestStr);
+    virtual void handleHTTPCmd_StreamingGET(char const* urlSuffix, char const* urlParams, char const* fullRequestStr);
+    // IHP: Adding url parsing
 
   protected:
     static void afterStreaming(void* clientData);
Index: liveMedia/include/ServerMediaSession.hh
===================================================================
--- liveMedia/include/ServerMediaSession.hh	(revision 14473)
+++ liveMedia/include/ServerMediaSession.hh	(revision 14474)
@@ -24,6 +24,12 @@
 #ifndef _SERVER_MEDIA_SESSION_HH
 #define _SERVER_MEDIA_SESSION_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _RTCP_HH
 #include "RTCP.hh"
 #endif
@@ -30,7 +36,7 @@
 
 class ServerMediaSubsession; // forward
 
-class ServerMediaSession: public Medium {
+class LIVEMEDIALIB_API ServerMediaSession: public Medium {
 public:
   static ServerMediaSession* createNew(UsageEnvironment& env,
 				       char const* streamName = NULL,
@@ -103,7 +109,7 @@
 };
 
 
-class ServerMediaSubsessionIterator {
+class LIVEMEDIALIB_API ServerMediaSubsessionIterator {
 public:
   ServerMediaSubsessionIterator(ServerMediaSession& session);
   virtual ~ServerMediaSubsessionIterator();
@@ -117,7 +123,7 @@
 };
 
 
-class ServerMediaSubsession: public Medium {
+class LIVEMEDIALIB_API ServerMediaSubsession: public Medium {
 public:
   unsigned trackNumber() const { return fTrackNumber; }
   char const* trackId();
Index: liveMedia/include/SimpleRTPSink.hh
===================================================================
--- liveMedia/include/SimpleRTPSink.hh	(revision 14473)
+++ liveMedia/include/SimpleRTPSink.hh	(revision 14474)
@@ -22,11 +22,17 @@
 #ifndef _SIMPLE_RTP_SINK_HH
 #define _SIMPLE_RTP_SINK_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MULTI_FRAMED_RTP_SINK_HH
 #include "MultiFramedRTPSink.hh"
 #endif
 
-class SimpleRTPSink: public MultiFramedRTPSink {
+class LIVEMEDIALIB_API SimpleRTPSink: public MultiFramedRTPSink {
 public:
   static SimpleRTPSink*
   createNew(UsageEnvironment& env, Groupsock* RTPgs,
Index: liveMedia/include/SimpleRTPSource.hh
===================================================================
--- liveMedia/include/SimpleRTPSource.hh	(revision 14473)
+++ liveMedia/include/SimpleRTPSource.hh	(revision 14474)
@@ -25,11 +25,17 @@
 #ifndef _SIMPLE_RTP_SOURCE_HH
 #define _SIMPLE_RTP_SOURCE_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MULTI_FRAMED_RTP_SOURCE_HH
 #include "MultiFramedRTPSource.hh"
 #endif
 
-class SimpleRTPSource: public MultiFramedRTPSource {
+class LIVEMEDIALIB_API SimpleRTPSource: public MultiFramedRTPSource {
 public:
   static SimpleRTPSource* createNew(UsageEnvironment& env, Groupsock* RTPgs,
 				    unsigned char rtpPayloadFormat,
Index: liveMedia/include/VideoRTPSink.hh
===================================================================
--- liveMedia/include/VideoRTPSink.hh	(revision 14473)
+++ liveMedia/include/VideoRTPSink.hh	(revision 14474)
@@ -21,11 +21,17 @@
 #ifndef _VIDEO_RTP_SINK_HH
 #define _VIDEO_RTP_SINK_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MULTI_FRAMED_RTP_SINK_HH
 #include "MultiFramedRTPSink.hh"
 #endif
 
-class VideoRTPSink: public MultiFramedRTPSink {
+class LIVEMEDIALIB_API VideoRTPSink: public MultiFramedRTPSink {
 protected:
   VideoRTPSink(UsageEnvironment& env,
 	       Groupsock* rtpgs, unsigned char rtpPayloadType,
Index: liveMedia/include/WAVAudioFileServerMediaSubsession.hh
===================================================================
--- liveMedia/include/WAVAudioFileServerMediaSubsession.hh	(revision 14473)
+++ liveMedia/include/WAVAudioFileServerMediaSubsession.hh	(revision 14474)
@@ -22,11 +22,17 @@
 #ifndef _WAV_AUDIO_FILE_SERVER_MEDIA_SUBSESSION_HH
 #define _WAV_AUDIO_FILE_SERVER_MEDIA_SUBSESSION_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _FILE_SERVER_MEDIA_SUBSESSION_HH
 #include "FileServerMediaSubsession.hh"
 #endif
 
-class WAVAudioFileServerMediaSubsession: public FileServerMediaSubsession{
+class LIVEMEDIALIB_API WAVAudioFileServerMediaSubsession: public FileServerMediaSubsession{
 public:
   static WAVAudioFileServerMediaSubsession*
   createNew(UsageEnvironment& env, char const* fileName, Boolean reuseFirstSource,
Index: liveMedia/include/WAVAudioFileSource.hh
===================================================================
--- liveMedia/include/WAVAudioFileSource.hh	(revision 14473)
+++ liveMedia/include/WAVAudioFileSource.hh	(revision 14474)
@@ -23,6 +23,12 @@
 #ifndef _WAV_AUDIO_FILE_SOURCE_HH
 #define _WAV_AUDIO_FILE_SOURCE_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _AUDIO_INPUT_DEVICE_HH
 #include "AudioInputDevice.hh"
 #endif
@@ -36,7 +42,7 @@
 } WAV_AUDIO_FORMAT;
 
 
-class WAVAudioFileSource: public AudioInputDevice {
+class LIVEMEDIALIB_API WAVAudioFileSource: public AudioInputDevice {
 public:
 
   static WAVAudioFileSource* createNew(UsageEnvironment& env,
Index: liveMedia/include/liveMedia.hh
===================================================================
--- liveMedia/include/liveMedia.hh	(revision 14473)
+++ liveMedia/include/liveMedia.hh	(revision 14474)
@@ -46,6 +46,7 @@
 #include "H265VideoStreamDiscreteFramer.hh"
 #include "JPEGVideoRTPSink.hh"
 #include "SimpleRTPSink.hh"
+#include "MetaDataRTPSink.hh"
 #include "uLawAudioFilter.hh"
 #include "MPEG2IndexFromTransportStream.hh"
 #include "MPEG2TransportStreamTrickModeFilter.hh"
Index: liveMedia/GenericMediaServer.cpp
===================================================================
--- liveMedia/GenericMediaServer.cpp	(revision 14473)
+++ liveMedia/GenericMediaServer.cpp	(revision 14474)
@@ -38,7 +38,7 @@
 }
 
 ServerMediaSession* GenericMediaServer
-::lookupServerMediaSession(char const* streamName, Boolean /*isFirstLookupInSession*/) {
+::lookupServerMediaSession(char const* streamName, char const* streamParams, Boolean /*isFirstLookupInSession*/) {
   // Default implementation:
   return (ServerMediaSession*)(fServerMediaSessions->Lookup(streamName));
 }
Index: liveMedia/H264or5VideoFileSink.cpp
===================================================================
--- liveMedia/H264or5VideoFileSink.cpp	(revision 14473)
+++ liveMedia/H264or5VideoFileSink.cpp	(revision 14474)
@@ -40,10 +40,20 @@
 }
 
 void H264or5VideoFileSink::afterGettingFrame(unsigned frameSize, unsigned numTruncatedBytes, struct timeval presentationTime) {
+  if (!fHaveWrittenFirstFrame) {
+    // IHP: calling virtual write functions
+    writeHeader(frameSize, presentationTime);
+    fHaveWrittenFirstFrame = True; // for next time
+  }
+
+  // IHP: calling virtual write functions
+  writeFrame(frameSize, numTruncatedBytes, presentationTime);
+}
+
+void H264or5VideoFileSink::writeHeader( unsigned frameSize, struct timeval presentationTime ) {
   unsigned char const start_code[4] = {0x00, 0x00, 0x00, 0x01};
 
-  if (!fHaveWrittenFirstFrame) {
-    // If we have NAL units encoded in "sprop parameter strings", prepend these to the file:
+  // If we have NAL units encoded in "sprop parameter strings", prepend these to the file:
     for (unsigned j = 0; j < 3; ++j) {
       unsigned numSPropRecords;
       SPropRecord* sPropRecords
@@ -54,12 +64,14 @@
       }
       delete[] sPropRecords;
     }
-    fHaveWrittenFirstFrame = True; // for next time
-  }
+}
 
+void H264or5VideoFileSink::writeFrame(unsigned frameSize, unsigned numTruncatedBytes, struct timeval presentationTime) {
+  unsigned char const start_code[4] = {0x00, 0x00, 0x00, 0x01};
+
   // Write the input data to the file, with the start code in front:
   addData(start_code, 4, presentationTime);
 
   // Call the parent class to complete the normal file write with the input data:
   FileSink::afterGettingFrame(frameSize, numTruncatedBytes, presentationTime);
-}
+}
\ No newline at end of file
Index: liveMedia/H264or5VideoStreamDiscreteFramer.cpp
===================================================================
--- liveMedia/H264or5VideoStreamDiscreteFramer.cpp	(revision 14473)
+++ liveMedia/H264or5VideoStreamDiscreteFramer.cpp	(revision 14474)
@@ -64,6 +64,13 @@
     nal_unit_type = 0xFF;
   }
 
+  // IHP: Adding some debugging stuff
+  u_int8_t nal_ref_idc = (fTo[0]&0x60)>>5;
+  #ifdef DEBUG
+    fprintf(stderr, "Parsed %d-byte NAL-unit (nal_ref_idc: %d, nal_unit_type: %d)\n",
+      frameSize, nal_ref_idc, nal_unit_type);
+  #endif
+
   // Begin by checking for a (likely) common error: NAL units that (erroneously) begin with a
   // 0x00000001 or 0x000001 'start code'.  (Those start codes should only be in byte-stream data;
   // *not* data that consists of discrete NAL units.)
Index: liveMedia/MPEGVideoStreamParser.hh
===================================================================
--- liveMedia/MPEGVideoStreamParser.hh	(revision 14473)
+++ liveMedia/MPEGVideoStreamParser.hh	(revision 14474)
@@ -21,6 +21,12 @@
 #ifndef _MPEG_VIDEO_STREAM_PARSER_HH
 #define _MPEG_VIDEO_STREAM_PARSER_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _STREAM_PARSER_HH
 #include "StreamParser.hh"
 #endif
@@ -30,7 +36,7 @@
 
 ////////// MPEGVideoStreamParser definition //////////
 
-class MPEGVideoStreamParser: public StreamParser {
+class LIVEMEDIALIB_API MPEGVideoStreamParser: public StreamParser {
 public:
   MPEGVideoStreamParser(MPEGVideoStreamFramer* usingSource,
 			FramedSource* inputSource);
Index: liveMedia/MediaSession.cpp
===================================================================
--- liveMedia/MediaSession.cpp	(revision 14473)
+++ liveMedia/MediaSession.cpp	(revision 14474)
@@ -1126,6 +1126,13 @@
 	if (sscanfResult == 1) {
 	  // <name>
 	  setAttribute(nameStr);
+  // IHP: The non-standard way CISCO represent width/height
+  // TODO: Make sure these aren't needed (don't seem to be)
+  //} else if( !strcmp(nameStr, "width") ) {
+  //  fVideoWidth = atoi(valueStr); 
+  //}
+  //else if( !strcmp(nameStr, "height") ) {
+  //  fVideoHeight = atoi(valueStr);
 	} else {
 	  // <name>=<value>
 	  setAttribute(nameStr, valueStr);
Index: liveMedia/MediaSink.cpp
===================================================================
--- liveMedia/MediaSink.cpp	(revision 14473)
+++ liveMedia/MediaSink.cpp	(revision 14474)
@@ -110,7 +110,7 @@
 
 ////////// OutPacketBuffer //////////
 
-unsigned OutPacketBuffer::maxSize = 60000; // by default
+unsigned OutPacketBuffer::maxSize = 100000;// IHP: Change from default 60000; // by default
 
 OutPacketBuffer
 ::OutPacketBuffer(unsigned preferredPacketSize, unsigned maxPacketSize, unsigned maxBufferSize)
Index: liveMedia/MetaDataRTPSink.cpp
===================================================================
--- liveMedia/MetaDataRTPSink.cpp	(nonexistent)
+++ liveMedia/MetaDataRTPSink.cpp	(revision 14474)
@@ -0,0 +1,99 @@
+/**********
+This library is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by the
+Free Software Foundation; either version 2.1 of the License, or (at your
+option) any later version. (See <http://www.gnu.org/copyleft/lesser.html>.)
+
+This library is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
+more details.
+
+You should have received a copy of the GNU Lesser General Public License
+along with this library; if not, write to the Free Software Foundation, Inc.,
+51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
+**********/
+
+////////////////////////////////////////////////////////////////////
+// Copyright 2011 intuVision, inc.
+// intuVision open source - all rights reserved.
+//
+// FILENAME : MetaDataRTPSink.cpp
+// AUTHORS  : Ashutosh Morde
+//            intuVision, Inc.
+//            10 Tower Park, Suite 200
+//            Woburn, MA  01801
+//            Email: ashu@intuvisiontech.com
+// DATE     : March 11, 2011
+// DERIVED  : SimpleRTPSink.cpp
+////////////////////////////////////////////////////////////////////
+
+#include "MetaDataRTPSink.hh"
+
+MetaDataRTPSink::MetaDataRTPSink(UsageEnvironment& env, Groupsock* RTPgs,
+			     unsigned char rtpPayloadFormat,
+			     unsigned rtpTimestampFrequency,
+			     char const* sdpMediaTypeString,
+			     char const* rtpPayloadFormatName,
+			     unsigned numChannels,
+			     Boolean allowMultipleFramesPerPacket,
+			     Boolean doNormalMBitRule)
+  : MultiFramedRTPSink(env, RTPgs, rtpPayloadFormat, rtpTimestampFrequency,
+		       rtpPayloadFormatName),
+    fAllowMultipleFramesPerPacket(allowMultipleFramesPerPacket) {
+  fSDPMediaTypeString
+    = strDup(sdpMediaTypeString == NULL ? "unknown" : sdpMediaTypeString);
+  fSetMBitOnLastFrames
+    = strcmp(fSDPMediaTypeString, "video") == 0 && doNormalMBitRule;
+}
+
+MetaDataRTPSink::~MetaDataRTPSink() {
+  delete[] (char*)fSDPMediaTypeString;
+}
+
+MetaDataRTPSink*
+MetaDataRTPSink::createNew(UsageEnvironment& env, Groupsock* RTPgs,
+			 unsigned char rtpPayloadFormat,
+			 unsigned rtpTimestampFrequency,
+			 char const* sdpMediaTypeString,
+			 char const* rtpPayloadFormatName,
+			 unsigned numChannels,
+			 Boolean allowMultipleFramesPerPacket,
+			 Boolean doNormalMBitRule) {
+  return new MetaDataRTPSink(env, RTPgs,
+			   rtpPayloadFormat, rtpTimestampFrequency,
+			   sdpMediaTypeString, rtpPayloadFormatName,
+			   numChannels,
+			   allowMultipleFramesPerPacket,
+			   doNormalMBitRule);
+}
+
+void MetaDataRTPSink::doSpecialFrameHandling(unsigned fragmentationOffset,
+					   unsigned char* frameStart,
+					   unsigned numBytesInFrame,
+					   struct timeval frameTimestamp,
+					   unsigned numRemainingBytes) {
+  if (numRemainingBytes == 0) {
+    setMarkerBit();
+  }
+
+   // Also set the RTP timestamp:
+  setTimestamp(frameTimestamp);
+  
+  // Important: Also call our base class's doSpecialFrameHandling(),
+  // to set the packet's timestamp:
+  MultiFramedRTPSink::doSpecialFrameHandling(fragmentationOffset,
+					     frameStart, numBytesInFrame,
+					     frameTimestamp,
+					     numRemainingBytes);
+}
+
+Boolean MetaDataRTPSink::
+frameCanAppearAfterPacketStart(unsigned char const* /*frameStart*/,
+			       unsigned /*numBytesInFrame*/) const {
+  return false;
+}
+
+char const* MetaDataRTPSink::sdpMediaType() const {
+  return fSDPMediaTypeString;
+}
Index: liveMedia/MultiFramedRTPSource.cpp
===================================================================
--- liveMedia/MultiFramedRTPSource.cpp	(revision 14473)
+++ liveMedia/MultiFramedRTPSource.cpp	(revision 14474)
@@ -195,6 +195,10 @@
 		<< fSavedMaxSize << ").  "
 		<< fNumTruncatedBytes << " bytes of trailing data will be dropped!\n";
       }
+      
+      // IHP: pass this frame along for post-processing
+      doSpecialPostprocessing( fReorderingBuffer->isEmpty() );
+
       // Call our own 'after getting' function, so that the downstream object can consume the data:
       if (fReorderingBuffer->isEmpty()) {
 	// Common case optimization: There are no more queued incoming packets, so this code will not get
@@ -260,7 +264,11 @@
 
     // Check for the 12-byte RTP header:
     if (bPacket->dataSize() < 12) break;
-    unsigned rtpHdr = ntohl(*(u_int32_t*)(bPacket->data())); ADVANCE(4);
+    unsigned rtpHdr = ntohl(*(u_int32_t*)(bPacket->data()));
+
+    // IHP: Allow RTP-level preprocessing
+    doSpecialPreprocessing( bPacket, rtpHdr); ADVANCE(4);
+
     Boolean rtpMarkerBit = (rtpHdr&0x00800000) != 0;
     unsigned rtpTimestamp = ntohl(*(u_int32_t*)(bPacket->data()));ADVANCE(4);
     unsigned rtpSSRC = ntohl(*(u_int32_t*)(bPacket->data())); ADVANCE(4);
Index: liveMedia/OnDemandServerMediaSubsession.cpp
===================================================================
--- liveMedia/OnDemandServerMediaSubsession.cpp	(revision 14473)
+++ liveMedia/OnDemandServerMediaSubsession.cpp	(revision 14474)
@@ -28,7 +28,8 @@
 				portNumBits initialPortNum,
 				Boolean multiplexRTCPWithRTP)
   : ServerMediaSubsession(env),
-    fSDPLines(NULL), fReuseFirstSource(reuseFirstSource),
+    fSDPLines(NULL), fControlLine(NULL),
+    fReuseFirstSource(reuseFirstSource),
     fMultiplexRTCPWithRTP(multiplexRTCPWithRTP), fLastStreamToken(NULL),
     fAppHandlerTask(NULL), fAppHandlerClientData(NULL) {
   fDestinationsHashTable = HashTable::create(ONE_WORD_HASH_KEYS);
@@ -431,6 +432,7 @@
   char const* rtcpmuxLine = fMultiplexRTCPWithRTP ? "a=rtcp-mux\r\n" : "";
   char const* rangeLine = rangeSDPLine();
   char const* auxSDPLine = getAuxSDPLine(rtpSink, inputSource);
+  char const* controlLine = getControlSPDLine();
   if (auxSDPLine == NULL) auxSDPLine = "";
 
   char const* const sdpFmt =
@@ -441,7 +443,7 @@
     "%s"
     "%s"
     "%s"
-    "a=control:%s\r\n";
+    "%s\r\n";
   unsigned sdpFmtSize = strlen(sdpFmt)
     + strlen(mediaType) + 5 /* max short len */ + 3 /* max char len */
     + strlen(ipAddressStr.val())
@@ -450,7 +452,7 @@
     + strlen(rtcpmuxLine)
     + strlen(rangeLine)
     + strlen(auxSDPLine)
-    + strlen(trackId());
+    + strlen(controlLine);
   char* sdpLines = new char[sdpFmtSize];
   sprintf(sdpLines, sdpFmt,
 	  mediaType, // m= <media>
@@ -462,7 +464,7 @@
 	  rtcpmuxLine, // a=rtcp-mux:... (if present)
 	  rangeLine, // a=range:... (if present)
 	  auxSDPLine, // optional extra SDP line
-	  trackId()); // a=control:<track-id>
+	  controlLine); // a=control:<track-id>
   delete[] (char*)rangeLine; delete[] rtpmapLine;
 
   fSDPLines = strDup(sdpLines);
@@ -469,7 +471,20 @@
   delete[] sdpLines;
 }
 
+// IHP: adding more info to 'a=control'
+char const* OnDemandServerMediaSubsession::getControlSPDLine( )
+{
+  if (trackId() == NULL) return NULL; // not yet in a ServerMediaSession
+
+  if (fControlLine == NULL) {
+    char buf[100];
+    sprintf(buf, "a=control:%s", trackId());
+    fControlLine = strDup( buf );
+  }
+  return fControlLine;
+}
 
+
 ////////// StreamState implementation //////////
 
 static void afterPlayingStreamState(void* clientData) {
Index: liveMedia/RTSPClient.cpp
===================================================================
--- liveMedia/RTSPClient.cpp	(revision 14473)
+++ liveMedia/RTSPClient.cpp	(revision 14474)
@@ -353,6 +353,19 @@
   fUserAgentHeaderStrLen = strlen(fUserAgentHeaderStr);
 }
 
+// IHP: Adding extra headers for SETUP
+void RTSPClient::setExtraSetupHeaders(char const* extraSetupHeaders) {
+  if (extraSetupHeaders == NULL || extraSetupHeaders[0] == '\0' ) return;
+
+  // Change the existing user agent header string:
+  char const* const formatStr = "%s\r\n";
+  unsigned const headerSize = strlen(formatStr) + strlen(extraSetupHeaders);
+  delete[] fExtraSetupHeaderStr;
+  fExtraSetupHeaderStr = new char[headerSize];
+  sprintf(fExtraSetupHeaderStr, formatStr, extraSetupHeaders);
+  fExtraSetupHeaderStrLen = strlen(fExtraSetupHeaderStr);
+}
+
 unsigned RTSPClient::responseBufferSize = 20000; // default value; you can reassign this in your application if you need to
 
 RTSPClient::RTSPClient(UsageEnvironment& env, char const* rtspURL,
@@ -364,7 +377,8 @@
     fTunnelOverHTTPPortNum(tunnelOverHTTPPortNum),
     fUserAgentHeaderStr(NULL), fUserAgentHeaderStrLen(0),
     fInputSocketNum(-1), fOutputSocketNum(-1), fBaseURL(NULL), fTCPStreamIdCount(0),
-    fLastSessionId(NULL), fSessionTimeoutParameter(0), fSessionCookieCounter(0), fHTTPTunnelingConnectionIsPending(False) {
+    fLastSessionId(NULL), fSessionTimeoutParameter(0), fSessionCookieCounter(0), fHTTPTunnelingConnectionIsPending(False),
+    fExtraSetupHeaderStr(NULL), fExtraSetupHeaderStrLen(0) { // IHP: Adding extra headers for SETUP
   setBaseURL(rtspURL);
 
   fResponseBuffer = new char[responseBufferSize+1];
@@ -402,6 +416,9 @@
 
   delete[] fResponseBuffer;
   delete[] fUserAgentHeaderStr;
+
+  // IHP: Adding extra headers for SETUP
+  delete[] fExtraSetupHeaderStr;
 }
 
 void RTSPClient::reset() {
@@ -708,11 +725,17 @@
     // Optionally include a "Blocksize:" string:
     char* blocksizeStr = createBlocksizeString(streamUsingTCP);
 
+    // IHP: Adding extra headers for SETUP
     // The "Transport:" and "Session:" (if present) and "Blocksize:" (if present) headers
     // make up the 'extra headers':
-    extraHeaders = new char[transportSize + strlen(sessionStr) + strlen(blocksizeStr)];
+    if (fExtraSetupHeaderStr == NULL) {
+      extraHeaders = new char[transportSize + strlen(sessionStr) + strlen(blocksizeStr)];
+      sprintf(extraHeaders, "%s%s%s", transportStr, sessionStr, blocksizeStr);
+    } else {
+      extraHeaders = new char[transportSize + strlen(sessionStr) + strlen(blocksizeStr) + fExtraSetupHeaderStrLen];
+      sprintf(extraHeaders, "%s%s%s%s", transportStr, sessionStr, blocksizeStr, fExtraSetupHeaderStr);
+    }
     extraHeadersWereAllocated = True;
-    sprintf(extraHeaders, "%s%s%s", transportStr, sessionStr, blocksizeStr);
     delete[] transportStr; delete[] sessionStr; delete[] blocksizeStr;
   } else if (strcmp(request->commandName(), "GET") == 0 || strcmp(request->commandName(), "POST") == 0) {
     // We will be sending a HTTP (not a RTSP) request.
@@ -999,6 +1022,7 @@
   char cmdName[RTSP_PARAM_STRING_MAX];
   char urlPreSuffix[RTSP_PARAM_STRING_MAX];
   char urlSuffix[RTSP_PARAM_STRING_MAX];
+  char urlParams[RTSP_PARAM_STRING_MAX];
   char cseq[RTSP_PARAM_STRING_MAX];
   char sessionId[RTSP_PARAM_STRING_MAX];
   unsigned contentLength;
@@ -1006,6 +1030,7 @@
 			      cmdName, sizeof cmdName,
 			      urlPreSuffix, sizeof urlPreSuffix,
 			      urlSuffix, sizeof urlSuffix,
+            urlParams, sizeof urlParams,
 			      cseq, sizeof cseq,
 			      sessionId, sizeof sessionId,
 			      contentLength)) {
Index: liveMedia/RTSPCommon.cpp
===================================================================
--- liveMedia/RTSPCommon.cpp	(revision 14473)
+++ liveMedia/RTSPCommon.cpp	(revision 14474)
@@ -48,6 +48,7 @@
   *url = '\0';
 }
 
+// IHP: Updating to parse urlParams
 Boolean parseRTSPRequestString(char const* reqStr,
 			       unsigned reqStrSize,
 			       char* resultCmdName,
@@ -56,6 +57,8 @@
 			       unsigned resultURLPreSuffixMaxSize,
 			       char* resultURLSuffix,
 			       unsigned resultURLSuffixMaxSize,
+             char* resultURLParams,
+             unsigned resultURLParamsMaxSize,
 			       char* resultCSeq,
 			       unsigned resultCSeqMaxSize,
                                char* resultSessionIdStr,
@@ -111,41 +114,62 @@
 
   // Look for the URL suffix (before the following "RTSP/"):
   parseSucceeded = False;
-  for (unsigned k = i+1; (int)k < (int)(reqStrSize-5); ++k) {
-    if (reqStr[k] == 'R' && reqStr[k+1] == 'T' &&
-	reqStr[k+2] == 'S' && reqStr[k+3] == 'P' && reqStr[k+4] == '/') {
-      while (--k >= i && reqStr[k] == ' ') {} // go back over all spaces before "RTSP/"
-      unsigned k1 = k;
-      while (k1 > i && reqStr[k1] != '/') --k1;
-
-      // ASSERT: At this point
-      //   i: first space or slash after "host" or "host:port"
-      //   k: last non-space before "RTSP/"
-      //   k1: last slash in the range [i,k]
-
-      // The URL suffix comes from [k1+1,k]
-      // Copy "resultURLSuffix":
-      unsigned n = 0, k2 = k1+1;
-      if (k2 <= k) {
-        if (k - k1 + 1 > resultURLSuffixMaxSize) return False; // there's no room
-        while (k2 <= k) resultURLSuffix[n++] = reqStr[k2++];
-      }
-      resultURLSuffix[n] = '\0';
-
-      // The URL 'pre-suffix' comes from [i+1,k1-1]
-      // Copy "resultURLPreSuffix":
-      n = 0; k2 = i+1;
-      if (k2+1 <= k1) {
-        if (k1 - i > resultURLPreSuffixMaxSize) return False; // there's no room
-        while (k2 <= k1-1) resultURLPreSuffix[n++] = reqStr[k2++];
-      }
-      resultURLPreSuffix[n] = '\0';
-      decodeURL(resultURLPreSuffix);
-
-      i = k + 7; // to go past " RTSP/"
-      parseSucceeded = True;
-      break;
-    }
+  // p -> presuffix, s -> suffix, m -> params, l -> lasts non-space
+  unsigned p = 0, s = i, m = 0, l = 0;
+  for (unsigned k = i+1; (int)k < (int)(reqStrSize-5); ++k) {
+    if (m == 0) {
+      if (reqStr[k] == '/') { p = s; s = k; continue; }
+      else if (reqStr[k] == '?') { m = k; continue; }
+    }
+    if (reqStr[k] == 'R' && reqStr[k+1] == 'T' &&
+        reqStr[k+2] == 'S' && reqStr[k+3] == 'P' && reqStr[k+4] == '/') {
+
+      if (m != 0 && l > m) {
+        // Read the parameters (m to l)
+        unsigned len = l - m;
+        if (len+1 > resultURLParamsMaxSize) return False; // there's no room
+        memcpy( resultURLParams, reqStr+m+1, len );
+        resultURLParams[len] = '\0';
+
+        // Read the suffix (s to m)
+        len = m - s - 1;
+        if (len+1 > resultURLSuffixMaxSize) return False; // there's no room
+        memcpy( resultURLSuffix, reqStr+s+1, len );
+        resultURLSuffix[len] = '\0';
+      }
+      else if (s != 0 && l > s) {
+        // No paramters were set
+        if (resultURLParamsMaxSize > 0) resultURLParams[0] = '\0';
+
+        // Read the suffix (s to l)
+        unsigned len = l - s;
+        if (len+1 > resultURLSuffixMaxSize) return False; // there's no room
+        memcpy( resultURLSuffix, reqStr+s+1, len );
+        resultURLSuffix[len] = '\0';
+      }
+      else
+      {
+        if (resultURLParamsMaxSize > 0) resultURLParams[0] = '\0';
+        if (resultURLSuffixMaxSize > 0) resultURLSuffix[0] = '\0';
+      }
+
+      if (p != 0) {
+        // Read the presuffix (p to s)
+        unsigned len = s - p - 1;
+        if (len+1 > resultURLPreSuffixMaxSize) return False; // there's no room
+        memcpy( resultURLPreSuffix, reqStr+p+1, len );
+        resultURLPreSuffix[len] = '\0';
+      }
+      else if (resultURLPreSuffixMaxSize > 0) {
+        // No presuffix were set
+        if (resultURLPreSuffixMaxSize > 0) resultURLPreSuffix[0] = '\0';
+      }
+
+      i = k + 7; // to go past " RTSP/"
+      parseSucceeded = True;
+      break;
+    }
+    else if (reqStr[k] != ' ') l = k;
   }
   if (!parseSucceeded) return False;
 
